/*
 * "NotUTF_8.java (c) Fall 2005 Columbia University"
 */

/* Servlet package */
package edu.columbia.xcap.error;

import edu.columbia.xcap.error.ErrorCodes;

import java.io.StringWriter;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;



/*
 * NotUTF_8 base class
 */
public class NotUTF_8 extends ErrorCodes
{
  // --------------------------------------------------------------------------
  /*
   * Method: NotUTF_8
   *         Constructor to initialize base class
   * @param  schemaLocation SchemaLocation for this error code
   * @param  reason descritive reason for this error code
   * <xs:element name="not-utf-8" substitutionGroup="error-element">
   *   <xs:annotation>
   *     <xs:documentation>
   *       This indicates that request could not be completed because it 
   *       would have produced a document not encoded in UTF-8.
   *     </xs:documentation>
   *   </xs:annotation>
   *   <xs:complexType>
   *     <xs:attribute name="phrase" type="xs:string" use="optional"/>
   *   </xs:complexType>
   * </xs:element>
   */
  public NotUTF_8(String schemaLocation, String reason)
  {
    super(schemaLocation, reason);
    if(_error == false)
    {
      _notUTF_8 = _document.createElement("not-well-formed"); 
      _notUTF_8.setAttribute("phrase", reason);
      _root.appendChild(_notUTF_8);
    }
  }; // NotUTF_8


  //---------------------------------------------------------------------------
  /**
   * Method: setPhrase
   *         Method to set the phrase attribute of the error code
   * @param  phrase the String phrase to be set
   */
  public void setPhrase(String phrase)
  {
    _notUTF_8.setAttribute("phrase", phrase);
  }; // setPhrase


  /**
   * Method: getNotUTF_8Element
   *         Method to get the not-well-formed element of this error tree
   * @return Element specifies the not-well-formed element
   */
  public Element getNotUTF_8Element()
  { 
    return _notUTF_8;
  }; // getNotUTF_8Element



  /* Element for this error type */
  private Element _notUTF_8;

}; // class NotUTF_8
