package edu.columbia.xcap.test;


import edu.columbia.xcap.appusage.AppUsage;
import edu.columbia.xcap.appusage.AppUsageFactory;

import edu.columbia.xcap.servlets.Put;
import edu.columbia.xcap.utils.XCAPException;

import edu.columbia.xcap.store.FileDocumentHandler;


/**
 * Test the creation or replacement of document
 */
class AddElement_Simple_NmSel
{

  public static void main(String[] args)
  {
    /** Create application usage and register it */
    String appName = "example";
    String defNamespaceName = "";
    String defNamespaceValue = "";
    String schemaLocation = 
      "/proj/irt-filer2/anurag/xcap/build/edu/columbia/xcap/test/rlschema.xsd";
    String auid = "resource-lists";
    String mimetype = "application/xcap-el+xml";

    try
    {
      AppUsage exampleUsage = new AppUsage(appName, defNamespaceName, 
          defNamespaceValue, schemaLocation, auid, mimetype);

      AppUsageFactory.INSTANCE.registerApplicationUsage(exampleUsage);

      String expr = "/services/resource-lists/users/bill/fr.xml/~~/resource-lists/list/namespace::*";
      String query = "";
      //String put = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><list name=\"friends\"><entry uri=\"sip:bob@example.com\"><display-name>Bob Jones</display-name></entry> <entry uri=\"sip:bob1@example.com\"><display-name>Bob1 Jones</display-name></entry></list>";
      String put = "<list name=\"more_friends\"><entry uri=\"sip:bob@example.com\"><display-name>Bob Jones</display-name></entry> <entry uri=\"sip:bob1@example.com\"><display-name>Bob1 Jones</display-name></entry><entry uri=\"sip:bob@example.com\"><display-name>Chakroo</display-name></entry></list>";

      /** Fire the put query */
      AppUsage appUsage = AppUsageFactory.INSTANCE.getApplicationUsage(auid);
      if(appUsage == null)
      {
        System.out.println("Hey appUsage is null");
      }
      else
      {
        FileDocumentHandler fileHandler = new FileDocumentHandler(expr, query);
        mimetype = "application/xcap-e+xml";
        fileHandler.putDocument(put, mimetype);
      }
    }
    catch(XCAPException exception)
    {
      System.out.println(exception.getCode() + " " + 
          exception.getErrorCode().getReason() + " " + 
          exception.getErrorCode().serialize());
    }
  }

}; // AddElement
