package edu.columbia.xcap.test;


import edu.columbia.xcap.appusage.AppUsage;
import edu.columbia.xcap.appusage.AppUsageFactory;

import edu.columbia.xcap.servlets.Put;
import edu.columbia.xcap.utils.XCAPException;

import edu.columbia.xcap.store.FileDocumentHandler;


/**
 * Test the creation or replacement of document
 */
class Get_NodeSelElementNotExists1
{

  public static void main(String[] args)
  {
    /** Create application usage and register it */
    String appName = "example";
    String defNamespaceName = "def";
    String defNamespaceValue = "urn:ietf:params:xml:ns:resource-lists";
    String schemaLocation = "/proj/irt-filer2/anurag/xcap/build/edu/columbia/xcap/test/rlschema.xsd";
    String auid = "resource-lists";
    String mimetype = "application/resource-lists+xml";

    try
    {
      AppUsage exampleUsage = new AppUsage(appName, defNamespaceName, 
          defNamespaceValue, schemaLocation, auid, mimetype);

      AppUsageFactory.INSTANCE.registerApplicationUsage(exampleUsage);

      String expr = 
        "/services/resource-lists/users/bill/fr.xml/~~/resource-lists/lists/entry[4]";
      String query = "";

      /** Fire the put query */
      AppUsage appUsage = AppUsageFactory.INSTANCE.getApplicationUsage(auid);
      if(appUsage == null)
      {
        System.out.println("Hey appUsage is null");
      }
      else
      {
        FileDocumentHandler fileHandler = new FileDocumentHandler(expr, query);
        System.out.println(fileHandler.getDocument());
      }
    }
    catch(XCAPException exception)
    {
      System.out.println(exception.getCode() + " " + 
          exception.getErrorCode().getReason() + " " + 
          exception.getErrorCode().serialize());
    }
  }

}; // Get_NodeSelElementNotExists
