package edu.columbia.xcap.test;

import edu.columbia.xcap.utils.*;
import edu.columbia.xcap.error.*;

import java.io.FileInputStream;

import edu.columbia.xcap.store.*;

/** HTTP definitions */
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import edu.columbia.xcap.appusage.AppUsage;
import edu.columbia.xcap.appusage.AppUsageFactory;

import java.lang.Exception;


class NoNodeSelector
{
  public static void main(String[] args)
  {
    /** Create application usage and register it */
    try
    {
      String appName = "resource-lists";
      String defNamespaceName = "urn:ietf:params:xml:ns";
      String defNamespaceValue = "xcap-caps";
      String schemaLocation = "example.appusage";
      String auid = "resource-lists";
      String mimetype = "application/xcap-caps+xml";

      AppUsage exampleUsage = new AppUsage(appName, defNamespaceName, 
          defNamespaceValue, schemaLocation, auid, mimetype);

      AppUsageFactory.INSTANCE.registerApplicationUsage(exampleUsage);


      // Case 32
      String expr = "/resource-lists/list/entry/";
      String query = "";
      print(expr, query);
      DocumentHandler handler = null;
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 32 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 32 PASSED!! *************");
      }

      // Case 33
      expr = "/resource-lists/list/entry/~~";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 33 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 33 PASSED!! *************");
      }

      // Case 34 
      expr = "/resource-lists/list/entry";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 34 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 34 PASSED!! *************");
      }
 
      // Case 35
      expr = "/resource-lists/list/entry/~~/";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 35 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 35 PASSED!! *************");
      }

      // Case 36
      expr = "/resource-lists/list/entry/~~/asd";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 36 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 36 PASSED!! *************");
      }

      // Case 37
      expr = "/resource-lists/list/entry/~~/asd/asd/asd/asd";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 37 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 37 PASSED!! *************");
      }

      // Case 38
      expr = "/resource-lists/list/entry/~~/asd/asd/asd/asd//";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 38 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 38 PASSED!! *************");
      }

      // Case 39
      expr = "/services/resource-lists/list/~~/";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 39 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 39 PASSED!! *************");
      }

      // Case 40
      expr = "/services/resource-lists/users";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 40 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 40 PASSED!! *************");
      }

      // Case 41
      expr = "/services/resource-lists/users/";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 41 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 41 PASSED!! *************");
      }

      // Case 42
      expr = "/services/resource-lists/users/bill";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 42 PASSED!! *************");

      // Case 43
      expr = "/services/resource-lists/users/bill/~~/";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 43 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 43 PASSED!! *************");
      }

      // Case 44
      expr = "/services/resource-lists/users/bill/~~/asd";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 44 PASSED!! *************");

      // Case 45
      expr = "/services/resource-lists/users/bill/~~/asd/[@xmlns=\"urn:ietf:xyz\"]";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 45 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 45 PASSED!! *************");
      }

      // Case 46
      expr = "/services/resource-lists/users/bill/~~/asd/[@xmlns=\"urn:ietf:xyz\"";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 46 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 46 PASSED!! *************");
      }

      // Case 47
      expr = "/services/resource-lists/users/bill/~~/asd/[@lns=\"urn:ietf:xyz\"";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        System.out.println("************ Case 47 PASSED!! *************");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        throw new Exception("Test Case 47 FAILED");
      }

      // Case 48
      expr = "/services/resource-lists/users/bill/~~/asd/*[@xmlns=\"urn:ietf:xyz\"]";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 48 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 48 PASSED!! *************");
      }

      // Case 49
      expr = "/services/resource-lists/users/bill/~~/asd/names[2][@xmlns=\"urn:ietf:xyz\"]";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 49 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 49 PASSED!! *************");
      }

      // Case 50
      expr = "/services/resource-lists/users/global";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 50 PASSED!! *************");

      // Case 51
      expr = "/services/resource-lists/global";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 51 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 51 PASSED!! *************");
      }

      // Case 52
      expr = "/services/resource-lists/global/hey";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 52 PASSED!! *************");

      // Case 53
      expr = "/services/resource-lists/global/hey/~~/";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 53 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 53 PASSED!! *************");
      }

      // Case 54
      expr = "/services/resource-lists/global/hey/~~/asda";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 54 PASSED!! *************");

      // Case 55
      expr = "/services/resource-li/users/bill";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 55 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 55 PASSED!! *************");
      }

      // Case 56
      expr = "/services/resource-li/users/bill/~~/asd";
      try
      {
        handler = new FileDocumentHandler(expr, query);
        throw new Exception("Test Case 56 FAILED");
      }
      catch(XCAPException exp)
      {
        System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
        System.out.println("************ Case 56 PASSED!! *************");
      }

      // Case 57
      expr = "/services/resource-lists/users/bill/~~/*asd[@id=asd\"]";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 57 PASSED!! *************");

      // Case 58
      expr = "/services/resource-lists/users/bill/~~/asd[2][@id=asd\"]";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 58 PASSED!! *************");

      // Case 59
      expr = "/services/resource-lists/users/bill/~~/asd/asdd[2][@id=asd\"]";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 59 PASSED!! *************");

      // Case 60
      expr = "/services/resource-lists/users/bill/~~/asd/asdd[2][@id=asd\"]/@id";
      handler = new FileDocumentHandler(expr, query);
      System.out.println("************ Case 60 PASSED!! *************");

      System.out.println("*****ALL PASSED*****");
    }
    catch(XCAPException exp)
    {
      System.out.println(exp.getCode() + " " + exp.getErrorCode().getReason());
      System.out.println("************ FAILED!! *************");
    }    
    catch(Exception exp)
    {
      System.out.println("Caught exception: " + exp.getMessage());
    }
  }; // main

  static void print(String expr, String query)
  {
    System.out.println("uri  : " + expr);
    System.out.println("query: " + query);
  }; // print
  
}; // NoNodeSelector
