/**
 * "SaxonParser.java (c) Fall 2005 Columbia University"
 */

/** Utils package */
package edu.columbia.xcap.test;

/** jaxp imports */
import javax.xml.xpath.XPathFactory;      // jaxp spec
import javax.xml.transform.sax.SAXSource; // Source for setting XPATHEvaluator
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.namespace.NamespaceContext;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPathExpressionException;

/** dom node, namespace imports */
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.ls.LSSerializer;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.xml.sax.InputSource;


/** java file */
import java.io.File;
import java.io.InputStream;
import java.io.StringReader;
import java.io.FileInputStream;
import java.io.ByteArrayInputStream;


/**
 * Class forms a base class for different parser implementations
 */
public class TestJAXP 
{
  public static void main(String args[])
  {

    String body = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><resource-lists> <list name=\"friends\"> <entry uri=\"sip:bob@example.com\"> <display-name>Bob Jones</display-name> </entry> </list> </resource-lists>";
    String put = "<entry uri=\"sip:anurag@example.com\"> <display-name>********Anurag******</display-name> </entry>";

    try
    {
    //  System.setProperty(DOMImplementationRegistry.PROPERTY, 
     //  System.setProperty("javax.xml.parsers.DocumentBuilderFactory",
     //     "net.sf.saxon.om.DocumentBuilderFactoryImpl");
    //      "org.apache.xerces.dom.DOMImplementationSourceImpl");
   //   System.setProperty(DOMImplementationRegistry.PROPERTY,
   //       "net.sf.saxon.om.DocumentBuilderFactoryImpl");
       // net.sf.saxon.dom.DocumentBuilderFactoryImpl.newInstance();
      DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
      dfactory.setNamespaceAware(true);
      DocumentBuilder builder = dfactory.newDocumentBuilder(); 
      Document complete = builder.parse(new InputSource( new StringReader((String)body)));
      Document inPut = builder.parse(new InputSource(new StringReader((String)put)));
      System.out.println("1");
      Node firstNode = inPut.getFirstChild();
      System.out.println("2");
      Node importedFirstNode = complete.importNode(firstNode, true);
      System.out.println("3");

      NodeList children = complete.getChildNodes();
      System.out.println("*******No of children********: " + children.getLength());

      for(int i=0; i<children.getLength(); i++)
      {
        Node child = children.item(i);
        System.out.println("*******Name of child********: " + child.getNodeName());
        System.out.println("*******No of child of the above node********: " + child.getChildNodes().getLength());

        try
        {
          DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
          DOMImplementationLS impl = (DOMImplementationLS)registry.getDOMImplementation("LS");

          LSSerializer writer = impl.createLSSerializer();
          System.out.println("*********FIRST CHILD***********");
          System.out.println(writer.writeToString(child));

          short nodeType = child.getNodeType(); 
          if(nodeType == Document.ELEMENT_NODE)
          {
            System.out.println("Got element node");
            System.out.println("element name: "+child.getNodeName());
            Element element = (Element)child;
            System.out.println("Child nodes of element: " + element.hasChildNodes());
            System.out.println("Child nodes of node: " + child.hasChildNodes());
          }
 //         System.out.println("\n"+"*********SECOND CHILD***********");
  //        System.out.println(writer.writeToString(a2));
    //      System.out.println("\n");
        }
        catch(org.w3c.dom.ls.LSException exp)
        {
          System.out.println("LSException error" + exp.getMessage());
        }
        catch(java.lang.ClassNotFoundException exp)
        {
          System.out.println("Class not found error" + exp.getMessage());
        }
        catch(java.lang.InstantiationException exp)
        {
          System.out.println("Instantiation exception" + exp.getMessage());
        }
        catch(java.lang.IllegalAccessException exp)
        {
          System.out.println("IllegalAccess exception" + exp.getMessage());
        }
      }

 //     complete.insertBefore(a2, importedFirstNode);
    }
    catch(javax.xml.parsers.ParserConfigurationException parserConfigError)
    {
      System.out.println(parserConfigError.getMessage());
    }
    catch(org.xml.sax.SAXException saxException)
    {
      System.out.println(saxException.getMessage());
    }
    catch(java.io.IOException exp)
    {
      System.out.println(exp.getMessage());
    }

  }
}
