package edu.columbia.xcap.test.obselete;
import edu.columbia.xcap.utils.XCAPException;

/** jaxp imports */
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

/** dom node, namespace imports */
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.ls.LSSerializer;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.xml.sax.InputSource;

import java.io.FileInputStream;

/** Parser import */
import edu.columbia.xcap.parser.SaxonParser;
import edu.columbia.xcap.parser.*;
import edu.columbia.xcap.utils.*;
import edu.columbia.xcap.error.*;
import javax.servlet.http.HttpServletResponse;
/** java file */
import java.io.StringReader;

import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;

import javax.xml.transform.Source;
import javax.xml.validation.Validator;

import java.io.FileInputStream;

import edu.columbia.xcap.appusage.*;

import java.io.*;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import java.io.StringReader;


class TestSchema
{

  public static void main(String[] args)
  {
    TestSchema testSchema = new TestSchema();
    testSchema.test(args);
  }

  public void test(String[] args)
  {
    /** Create application usage and register it */
    try
    {
      FileInputStream fileIpStr = new FileInputStream(args[1]);
      SchemaValidator schemaValidator = 
        new SchemaValidator(SchemaConstants.DOCUMENT);

      DOMXMLParser domXMLParser = new DOMXMLParser(true);
      Node node = domXMLParser.parse(fileIpStr);
      String result = SaxonParser.print(node, "XML File");

     /* try
      {
        File file = new File("./out.xsd");
        if(file.createNewFile() == true)
        {
          System.out.println("New file created");
        } 
        else 
        {
          System.out.println("File exists, will overwrite");
        }

        TransformerFactory tfactory = TransformerFactory.newInstance(); 
        Transformer serializer = tfactory.newTransformer(); 
        StreamSource streamSource = new StreamSource(new StringReader(result));
        StreamResult streamResult = new StreamResult(file);
        serializer.transform(streamSource, streamResult);
      }
      catch(Exception exception)
      {
        throw new XCAPException(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, 
            new NullError(SchemaConstants.NULLSCHEMA, "Could not write file"));
      }
       */ 
      
      schemaValidator.validateSchema(args[0], result);
    }
    catch(XCAPException exception)
    {
      System.out.println("++++++++++");
      System.out.println(exception.getReason());
      System.out.println("++++++++++");
    }
    catch(java.io.FileNotFoundException exception)
    {
      System.out.println(exception.getCause());
    }
  }


  public String print(Node nodeToBePrinted, String msg)
    throws XCAPException
  {
    System.out.println("-->SaxonParser::print");
    String result = null;
    try
    {
      DOMImplementationRegistry registry = 
        DOMImplementationRegistry.newInstance();
      DOMImplementationLS impl = 
        (DOMImplementationLS)registry.getDOMImplementation("LS");

      LSSerializer writer = impl.createLSSerializer();
      System.out.println("*********" +msg+"***********");
      result = writer.writeToString(nodeToBePrinted);
      System.out.println(result);
      System.out.println("\n");
    }
    catch(org.w3c.dom.ls.LSException exp)
    {
      System.out.println("LSException error" + exp.getMessage());
    }
    catch(java.lang.ClassNotFoundException exp)
    {
      System.out.println("Class not found error" + exp.getMessage());
    }
    catch(java.lang.InstantiationException exp)
    {
      System.out.println("Instantiation exception" + exp.getMessage());
    }
    catch(java.lang.IllegalAccessException exp)
    {
      System.out.println("IllegalAccess exception" + exp.getMessage());
    }
    System.out.println("SaxonParser::print-->");
    return result;
  }



}; // TestSchema
