/**
 * "GetInitialData.java (c) Fall 2005 Columbia University"
 */

/** GetInitialData package */
package edu.columbia.xcap.utils;

import java.lang.Thread;
import java.net.Socket;
import java.net.ServerSocket;

import edu.columbia.xcap.error.*;
import edu.columbia.xcap.utils.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import edu.columbia.xcap.utils.*;

/**
 * Class responsible for accepting connections for different PAs
 */
public class GetInitialData extends Thread
{

  /**
   * Method: GetInitialData
   *         Constructor to construct the server side socket
   * @throws XCAPException        
   */
  public GetInitialData()
    throws XCAPException
  {
  }; // GetInitialData
  
  
  /**
   * Method: run
   *         Thread implementation. Methods accepts tcp connections and
   *         stores the ip and port. Only the latest connection is stored, so 
   *         everytime a  client connects the previous connection is closed
   */
  public void run()
  {
    System.out.println("-->GetInitialData::run");
    try
    {
      NotifyChange notifyChange = new NotifyChange();
      while(true)
      {
          notifyChange.accept();
          MySocket mySocket = notifyChange.getSocket();
          String read = mySocket.read();
          Thread.sleep(1);
          mySocket.write("DONE");
          mySocket.close();
          Thread.sleep(1);
        }
    }
    catch(java.io.IOException exception)
    {
    }
    catch(XCAPException exception)
    {
    }
    catch(java.lang.InterruptedException exception)
    {
    }
    System.out.println("GetInitialData::run-->");
  }; // run

 
  /** My socket class wrapper to read data */
  private MySocket m_mySocket;

}; // GetInitialData
