/**
 * "MRUObject.java (c) Fall 2005 Columbia University"
 */

/** MRUObject package */
package edu.columbia.xcap.utils;


/** Value in the map */
import org.w3c.dom.Node;

import java.lang.*;

/**
 * Encapsulation of key as Node + last_mod_time
 */
public class MRUObject
{
  //----------------------------------------------------------------------------
  /**
   * Method: MRUObject
   *         Constructor to construct empty cache of the given size
   * @param  maxObjectSize specifies the max cache size
   */
  public MRUObject(String lastModTime, Node node)
  {
    _lastModeTime = lastModTime;
    _node         = node; 
  }; // MRUObject


  /**
   * Method: getNode
   *         Method to get a node
   */
  public Node getNode()
  {
    return _node;
  }; // getNode


  /** 
   * Method: getLastModTime
   *         Method to get the last mod time
   */
  public String getLastModTime()
  {
    return _lastModeTime;
  }; // putNode
  

  /** MRU Value Last mod time */
  private String _lastModeTime;

  /** MRU Value Node */
  private Node _node;

}; // class MRUObject
